//
//  ViewController.swift
//  demo15-搜索条（UISearchBar）的用法
//
//  Created by zero on 16/12/28.
//  Copyright © 2016年 yunhaitechnology. All rights reserved.
//

import UIKit

class ViewController: UIViewController,UISearchBarDelegate,UITableViewDelegate,UITableViewDataSource {

    @IBOutlet weak var searchBar: UISearchBar!
    @IBOutlet weak var tableView: UITableView!
    //所有组件
    var ctrls:[String] = ["Label","Button1","Button2","Switch"]
    //搜索匹配的结果
    var ctrlsel:[String] = []
    
    override func viewDidLoad() {
        super.viewDidLoad()
        //起始加载全部内容
        self.ctrlsel = self.ctrls
        self.searchBar.delegate = self
        self.tableView.delegate = self
        self.tableView.dataSource = self
        //注册cell
        self.tableView.register(UITableViewCell.self, forCellReuseIdentifier: "swiftCell")
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.ctrlsel.count
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let identifier:String = "swiftCell"
        // 同一形式的单元格重复使用，在声明时已注册
        let cell = tableView.dequeueReusableCell(withIdentifier: identifier, for: indexPath)
        cell.accessoryType = UITableViewCellAccessoryType.disclosureIndicator
        cell.textLabel?.text = self.ctrlsel[indexPath.row]
        return cell
    }
    // 搜索代理UISearchBarDelegate方法，每次改变搜索内容时都会调用
    func searchBar(_ searchBar: UISearchBar, textDidChange searchText: String) {
        //没有搜索内容是显示全部组件
        if searchText == "" {
            self.ctrlsel = self.ctrls
        }else{//匹配用户输入内容的前缀
            self.ctrlsel = []
            for ctrl in self.ctrls {
                if ctrl.lowercased().hasPrefix(searchText.lowercased()) {
                    self.ctrlsel.append(ctrl)
                }
            }
        }
        self.tableView.reloadData()
    }

}

